/**
 * OS main method
 */
extern "C" void createKernel(multiboot_info_t* multiboot_info,
		unsigned int magicNumber) {
	Video cout;
	cout.clear();
	cout.setColor(0x0F);

	const char gdtIdtLoaded[] = "GDT/IDT loaded!";
	if (magicNumber == 0x2BADB002) {
		installGdt();

		installIdt();
		installRequests();
		installRoutines();

		installTimer();
		installKeyboard();

		//enable_paging(multiboot_info);

		asm volatile ("sti");
		cout.print(gdtIdtLoaded);

		//Kernel kernel(multiboot_info);
		//kernel.run();
	} else {
		const char grub_failed[] = "GRUB failed";
		cout.print(grub_failed);
	}
}