extern _panicHandler

defaultRoutine:
        pusha
        push ds
        push es
        push fs
        push gs

        mov ax, 0x10
        mov ds, ax
        mov es, ax
        mov fs, ax
        mov gs, ax

        mov eax, esp
        push eax

        mov eax, _panicHandler
        call eax

        pop eax
        pop gs
        pop fs
        pop es
        pop ds
        popa

        add esp, 8
        iret



; Divide by zero exception
global _irout0
_irout0:
        cli
        push byte 0
        push byte 0
        jmp defaultRoutine

; Debug exception
global _irout1
_irout1:
        cli
        push byte 0
        push byte 1
        jmp defaultRoutine

; Non-maskable interrupt exception
global _irout2
_irout2:
        cli
        push byte 0
        push byte 2
        jmp defaultRoutine

; Breakpoint exception
global _irout3
_irout3:
        cli
        push byte 0
        push byte 3
        jmp defaultRoutine

; Detected overflow exception
global _irout4
_irout4:
        cli
        push byte 0
        push byte 4
        jmp defaultRoutine

; Out of bounds exception
global _irout5
_irout5:
        cli
        push byte 0
        push byte 5
        jmp defaultRoutine

; Invalid operation code exception
global _irout6
_irout6:
        cli
        push byte 0
        push byte 6
        jmp defaultRoutine

; No coprocessor exception
global _irout7
_irout7:
        cli
        push byte 0
        push byte 7
        jmp defaultRoutine

; Double fault exception [has error code]
global _irout8
_irout8:
        cli
        push byte 8
        jmp defaultRoutine

; Coprocessor segment overrun exception
global _irout9
_irout9:
        cli
        push byte 0
        push byte 9
        jmp defaultRoutine

; Bad TSS exception [has error code]
global _irout10
_irout10:
        cli
        push byte 10
        jmp defaultRoutine

; Segment not present exception [has error code]
global _irout11
_irout11:
        cli
        push byte 11
        jmp defaultRoutine

; Stack fault exception [has error code]
global _irout12
_irout12:
        cli
        push byte 12
        jmp defaultRoutine

; General protection fault exception [has error code]
global _irout13
_irout13:
        cli
        push byte 13
        jmp defaultRoutine

; Page fault exception [has error code]
global _irout14
_irout14:
        cli
        push byte 14
        jmp defaultRoutine

; Unknown interrupt exception
global _irout15
_irout15:
        cli
        push byte 0
        push byte 15
        jmp defaultRoutine

; Coprocessor fault exception
global _irout16
_irout16:
        cli
        push byte 0
        push byte 16
        jmp defaultRoutine

; Alignment check exception
global _irout17
_irout17:
        cli
        push byte 0
        push byte 17
        jmp defaultRoutine

; Machine check exception
global _irout18
_irout18:
        cli
        push byte 0
        push byte 18
        jmp defaultRoutine

; Reserved exceptions
global _irout19
_irout19:
        cli
        push byte 0
        push byte 19
        jmp defaultRoutine

global _irout20
_irout20:
        cli
        push byte 0
        push byte 20
        jmp defaultRoutine

global _irout21
_irout21:
        cli
        push byte 0
        push byte 21
        jmp defaultRoutine

global _irout22
_irout22:
        cli
        push byte 0
        push byte 22
        jmp defaultRoutine

global _irout23
_irout23:
        cli
        push byte 0
        push byte 23
        jmp defaultRoutine

global _irout24
_irout24:
        cli
        push byte 0
        push byte 24
        jmp defaultRoutine

global _irout25
_irout25:
        cli
        push byte 0
        push byte 25
        jmp defaultRoutine

global _irout26
_irout26:
        cli
        push byte 0
        push byte 26
        jmp defaultRoutine

global _irout27
_irout27:
        cli
        push byte 0
        push byte 27
        jmp defaultRoutine

global _irout28
_irout28:
        cli
        push byte 0
        push byte 28
        jmp defaultRoutine

global _irout29
_irout29:
        cli
        push byte 0
        push byte 29
        jmp defaultRoutine

global _irout30
_irout30:
        cli
        push byte 0
        push byte 30
        jmp defaultRoutine

global _irout31
_irout31:
        cli
        push byte 0
        push byte 31
        jmp defaultRoutine
